=== debian/control ===
Source: ros-indigo-libpointmatcher
Section: misc
Priority: extra
Maintainer: Francois Pomerleau <f.pomerleau@gmail.com>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libeigen3-dev, ros-indigo-libnabo
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-libpointmatcher
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, ros-indigo-catkin, ros-indigo-libnabo
Description: libpointmatcher is a modular ICP library, useful for robotics and computer vision.
